import re

from si_tests import settings


def get_cluster_kubeconfig(remote, cluster_name, mgmt_cluster=True):
    kubeconfig_output = "kubeconfig" if mgmt_cluster else f"kubeconfig-{settings.REGIONAL_CLUSTER_NAME}"
    kubeconfig_input = settings.KUBECONFIG_KIND_PATH
    if not mgmt_cluster:
        kubeconfig_input = "kubeconfig" if remote.isfile("kubeconfig") else \
            "{0}/kubeconfig".format(settings.KAAS_BOOTSTRAP_TARGET_DIR)
    try:
        result = remote.execute(
            command=f"./{settings.KAAS_BOOTSTRAP_TARGET_DIR}/container-cloud get cluster-kubeconfig " +
            f"--cluster-name {cluster_name} " +
            f"--kubeconfig-output {kubeconfig_output} " +
            f"--kubeconfig {kubeconfig_input}",
            verbose=True, timeout=30)
        return result and result.exit_code == 0
    except Exception:
        return False


def is_bootstrap_version_dev(version):
    rx_dev = r'\d+\.\d+\.\d+-\d+-[0-9a-f]+'
    return re.match(rx_dev, version)


def extract_clean_kaasrelease_version(kr_name):
    rx_clean = r'\d+.\d+.\d+'
    return re.search(rx_clean, kr_name).group(0)
